// Generated by CoffeeScript 1.10.0

/*
express middleware to validate requests.
 */
var _validate, boom, validator;

validator = require('..');

boom = require('boom');

exports.validateRequest = function(field, schema, options) {
  return function(req, res, next) {
    return _validate(req[field], "req." + field, schema, options, next);
  };
};

exports.validateResponse = function(field, schema, options) {
  return function(req, res, next) {
    return _validate(res[field], "res." + field, schema, options, next);
  };
};

_validate = function(obj, key, schema, options, next) {
  var cleanedObject, dataPath, result;
  if (schema == null) {
    schema = {};
  }
  if (options == null) {
    options = {};
  }
  if (schema.type == null) {
    schema.type = 'object';
  }
  if (options.banUnknownProperties == null) {
    options.banUnknownProperties = false;
  }
  if (options.checkRecursive == null) {
    options.checkRecursive = false;
  }
  cleanedObject = JSON.parse(JSON.stringify(obj));
  result = validator.validateResult(cleanedObject, schema, options.checkRecursive, options.banUnknownProperties);
  if (result.valid) {
    return next();
  } else {
    dataPath = result.error.dataPath;
    try {
      dataPath = dataPath.replace(/^\//, '');
    } catch (undefined) {}
    return next(boom.badRequest((result.error.toString()) + " at '" + dataPath + "' in " + key));
  }
};
