// Generated by CoffeeScript 1.10.0
var tv4;

tv4 = require('tv4');

tv4.addFormat('objectid', function(data) {
  if (typeof data === 'string' && /^[a-f\d]{24}$/i.test(data)) {
    return null;
  }
  return "objectid expected";
});

tv4.addFormat('date-time', function(data) {
  var dateTimeRegex;
  dateTimeRegex = /\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d:[0-5]\d\.\d+([+-][0-2]\d:[0-5]\d|Z)/;
  if (typeof data === 'string' && dateTimeRegex.test(data)) {
    return null;
  }
  return "date-time, ISOString format, expected";
});

tv4.addFormat('date', function(data) {
  if (typeof data === 'string' && /\d{4}-[01]\d-[0-3]\d/.test(data)) {
    return null;
  }
  return "date, YYYY-MM-DD format, expected";
});

tv4.addFormat('time', function(data) {
  if (typeof data === 'string' && /^[0-2][0-9]:[0-5][0-9](:[0-5][0-9])?$/.test(data)) {
    return null;
  }
  return "time, HH:mm:ss or HH:mm format, expected";
});

tv4.addFormat('email', function(data) {
  var emailRegex;
  emailRegex = /[a-z0-9!#$%&'*+\/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+\/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?/;
  if (typeof data === 'string' && emailRegex.test(data)) {
    return null;
  }
  return "email expected";
});

tv4.addFormat('non-negative-integer', function(data) {
  if (typeof data === 'string' && /^[0-9]+$/.test(data)) {
    return null;
  }
  return "non negative integer expected";
});

module.exports = tv4;
